from fastapi import FastAPI
from fastapi.middleware.cors import CORSMiddleware

from .router import router
from .settings import Settings

app = FastAPI(title="Fooder")
app.include_router(router)


app.add_middleware(
    CORSMiddleware,
    allow_origins=Settings().ALLOWED_ORIGINS,
    allow_credentials=True,
    allow_methods=["*"],
    allow_headers=["*"],
)
