from datetime import date

from fastapi import APIRouter, Depends, Request

from ..controller.diary import GetDiary
from ..model.diary import Diary

router = APIRouter(tags=["diary"])


@router.get("", response_model=Diary)
async def get_diary(
    request: Request,
    date: date,
    controller: GetDiary = Depends(GetDiary),
):
    return await controller.call(date)
